StVn = 0.10; --Version number;
Show_Hide = 1;
Start_Damage = 0;
Total_Damage = 0;
DPS = 0;
local Time_Start;
local Time_Recent;
local Time_Total;
local Text_Color;
Text_Color = "|cffff8800";
DPSmSet = {};

function echo(words)
	DEFAULT_CHAT_FRAME:AddMessage(words)
end

function DPSmeter_OnLoad(this)
	this:RegisterEvent("COMBATMETER_DAMAGE");
	this:RegisterEvent("VARIABLES_LOADED");
	echo("|cff92ebff##DPSmeter loaded: |r|cffffd9f4Version " .. StVn .. "|r");
	echo("|cff92ebff##Toggle DPSmeter with '/dm'|r");
	echo("|cff92ebff##Use '/dm info' to view all usable commands|r");
	SlashCmdList["DPSMETER"] = DPSmeter_SlashCmdHandler;
	SLASH_DPSMETER1 = "/dpsmeter";
	SLASH_DPSMETER2 = "/dm";
end

function DPSmeter_SlashCmdHandler(ebox, var)
	local switch, value = DPSmeter_ColorSlash(var);

	if (switch == "info") then
		echo("==========================");
		echo("-DPSmeter Information-");
		echo("DPSmeter Version: "..StVn);
		echo("            Commands:");
		echo("/dm r     - Reset Position");
		echo("/dm       - Hide/Show");
		echo("/dm info - Info");
		echo("/dm color ffffff - Change text color, in hex");
		echo("==========================");
	elseif (switch == "r") then
		DPSmeter:SetPos(1,300);
		DPSmSet["X"] = 1;
		SaveVariables("DPSmSet");
		DPSmSet["Y"] = 300;
		SaveVariables("DPSmSet");
	elseif (switch == "color") then
		if (string.len(value) == 6) then
			DPSmSet["Tcolor"] = "|cff"..value;
			SaveVariables("DPSmSet");
			local Text_Color = "|cff"..value;
			DPSmeter_TextBox:SetText(DPSmSet["Tcolor"].."DPS: "..DPS.."|r");
			echo("|cff92ebffDPSmeter:|r Text color changed to '"..value.."'");
		else
			echo("|cff92ebffDPSmeter:|r Color value improper length. Please use 6 hexadecimal numbers");
		end
	else
		if (Show_Hide == 1) then
			Show_Hide = 0;
			DPSmeter:Hide();
		elseif (Show_Hide == 0) then
			Show_Hide = 1;
			DPSmeter:Show();
		else
			echo("|cff92ebffPSmeter:|r Show/Hide error");
		end
	end
end

function DPSmeter_OnEvent(this, event, arg1, arg2, arg3, arg4) --This function taken from adPanelDps, math credits go to him;
	if (event == "COMBATMETER_DAMAGE") then
		if (_source == UnitName("player")) then
			if (Start_Damage == 0) then
				Start_Damage = 1;
				Time_Start = (GetTime() - 1);
				Total_Damage = 0;
				DPS = 0;
			end
			
			Time_Total = (GetTime() - Time_Start);
			Time_Recent = GetTime();
			Total_Damage = Total_Damage + _damage;
			DPS = math.floor(Total_Damage / Time_Total);
		end
	end
	if (event == "VARIABLES_LOADED") then
		if (DPSmSet["X"] == nil and DPSmSet["Y"] == nil) then
			DPSmSet["X"] = 1;
			SaveVariables("DPSmSet");
			DPSmSet["Y"] = 300;
			SaveVariables("DPSmSet");
		else
			--Set position;
			DPSmeter:SetPos(DPSmSet["X"], DPSmSet["Y"]);
		end

		if (DPSmSet["Tcolor"] == nil) then
			DPSmSet["Tcolor"] = "|cffff8800";
			SaveVariables("DPSmSet");
			DPSmeter_TextBox:SetText(Text_Color.."DPS: "..DPS.."|r");
		else
			DPSmeter_TextBox:SetText(DPSmSet["Tcolor"].."DPS: "..DPS.."|r");
		end
	end
	if (event == "LOADING_END") then
		if (DPSmSet["X"] == nil and DPSmSet["Y"] == nil) then
			DPSmSet["X"] = 1;
			SaveVariables("DPSmSet");
			DPSmSet["Y"] = 300;
			SaveVariables("DPSmSet");
		else
			--Set position;
			DPSmeter:SetPos(DPSmSet["X"], DPSmSet["Y"]);
		end

		if (DPSmSet["Tcolor"] == nil) then
			DPSmSet["Tcolor"] = "|cffff8800";
			SaveVariables("DPSmSet");
			DPSmeter_TextBox:SetText(Text_Color.."DPS: "..DPS.."|r");
		else
			DPSmeter_TextBox:SetText(DPSmSet["Tcolor"].."DPS: "..DPS.."|r");
		end
	end
	if (event == "ZONE_CHANGE") then
		if (DPSmSet["X"] == nil and DPSmSet["Y"] == nil) then
			DPSmSet["X"] = 1;
			SaveVariables("DPSmSet");
			DPSmSet["Y"] = 300;
			SaveVariables("DPSmSet");
		else
			--Set position;
			DPSmeter:SetPos(DPSmSet["X"], DPSmSet["Y"]);
		end

		if (DPSmSet["Tcolor"] == nil) then
			DPSmSet["Tcolor"] = "|cffff8800";
			SaveVariables("DPSmSet");
			DPSmeter_TextBox:SetText(Text_Color.."DPS: "..DPS.."|r");
		else
			DPSmeter_TextBox:SetText(DPSmSet["Tcolor"].."DPS: "..DPS.."|r");
		end
	end
end

function DPSmeter_OnUpdate()
	if (not Time_Recent) then
		Time_Recent = 0;
	end
	if (not Start_Damage) then
		Start_Damage = 0;
	end
	if (GetTime() - Time_Recent > 10) then
		Start_Damage = 0;
	end
	if (DPSmSet["Tcolor"] == nil) then
		DPSmSet["Tcolor"] = "|cffff8800";
		SaveVariables("DPSmSet");
		DPSmeter_TextBox:SetText(Text_Color.."DPS: "..DPS.."|r");
	else
		DPSmeter_TextBox:SetText(DPSmSet["Tcolor"].."DPS: "..DPS.."|r");
	end
	
end

function DPSmeter_Moved()
	X, Y = DPSmeter:GetPos();
	if ( X <= 0) then
		echo("X is off map, using defaults");
		DPSmSet["X"] = 1;
		SaveVariables("DPSmSet");
	else
		DPSmSet["X"] = X;
		SaveVariables("DPSmSet");
	end
	if ( Y <= 0) then
		echo("Y is off map, using defaults");
		DPSmSet["Y"] = 300;
		SaveVariables("DPSmSet");
	else
		DPSmSet["Y"] = Y;
		SaveVariables("DPSmSet");
	end
end

function DPSmeter_ColorSlash(command)
	if command then
		local a, b = string.find(command, "%s");
		if a then
			local c = string.sub(command, 1, a-1);
			local d = string.sub(command, b+1);
			return c,d;
		else	
			return command,nil;
		end
	end
end
